/**
 * Cecilia, an implementation of the Fractal component model in C.
 * 
 * Copyright (C) 2006-2007 STMicroelectronics
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * Contact: fractal@objectweb.org
 *
 * Authors: Matthieu Leclercq.
 */

#ifndef FRACTAL_API_CLONEABLECOMPOSITE_H
#define FRACTAL_API_CLONEABLECOMPOSITE_H

#ifndef IN_CECILIA_MECHANISM
#error You must not include this file in standard component
#endif

// include generated header file from IDL fractal.api.Factory
#include <fractal/api/Factory.idl.h>
// include generated header file from IDL memory.api.Allocator
#include <memory/api/Allocator.idl.h>

#include <fractal/api/defaultComposite.h>

struct __cecilia_cloneableCompositeData_t {
  struct __cecilia_defaultCompositeData_t defaultComposite;
  Rfractal_api_Factory factory;
  Rmemory_api_Allocator* factory_allocator;
};

extern struct Mfractal_api_Component
    __cecilia_cloneableComposite_ComponentMeths;
extern struct Mfractal_api_BindingController 
    __cecilia_cloneableComposite_BindingControllerMeths;
extern struct Mfractal_api_Factory 
    __cecilia_cloneableComposite_FactoryMeths;

#endif // FRACTAL_API_CLONEABLECOMPOSITE_H
